
#include <stdio.h>
#include "pvm3.h"

#include "life.h"

void main() {
  int node_id ;
  int tids [NNODES] ;
  int blockSizeMax = (N + NNODES - 1) / NNODES ;
  int *block ;
  int iter ;

  pvm_mytid() ;

  /*  Create the node processes.  */

  pvm_spawn("life.worker", NULL, PvmTaskDefault, "", NNODES, tids);

  /*  Send `node_id' and `tids' vector to all nodes.  */

  for(node_id = 0 ; node_id < NNODES ; node_id++) {
    pvm_psend(tids [node_id], 0, &node_id, 1, PVM_INT) ;
    pvm_psend(tids [node_id], 0, tids, NNODES, PVM_INT) ;
  }

  /*  Handle output.  */

  block = (int *) malloc(blockSizeMax * N * sizeof(int)) ;

  for(iter = 0 ; iter <= NITER ; iter++) {

    /*  Copy current state of board from nodes to a `.pgm' file.  */

    char fname [256] ;
    FILE* f ;
 
    sprintf(fname, "life%2.2d.pgm", iter) ;

    f = fopen(fname, "w") ;
    fprintf(f, "P2\n%3d  %3d\n%3d\n", N, N, 1) ;

    for(node_id = 0 ; node_id < NNODES ; node_id++) {
      int len, blockLen, dummy ;
      int i ;

      pvm_precv(tids [node_id], 1, block, blockSizeMax * N, PVM_INT,
                &dummy, &dummy, &len) ;

      blockLen = len / sizeof(int) ;

      for(i = 0 ; i < blockLen ; i++) {
        fprintf(f, "%d ", block [i]) ;
        if(i % 20 == 19) fprintf(f, "\n") ;
      }
    }

    fclose(f) ;
  }

  pvm_exit() ;
}

